models/Tematicas.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "tematicas".
 *
 * @property int $id_tematica
 * @property string $tematica
 * @property int $id_padre
 *
 * @property Reproducen[] $reproducens
 * @property Libros[] $libros
 * @property Tematicas $padre
 * @property Tematicas[] $tematicas
 */
class Tematicas extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'tematicas';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id_padre'], 'integer'],
            [['tematica'], 'string', 'max' => 255],
            [['id_padre'], 'exist', 'skipOnError' => true, 'targetClass' => Tematicas::className(), 'targetAttribute' => ['id_padre' => 'id_tematica']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id_tematica' => 'Id Tematica',
            'tematica' => 'Tematica',
            'id_padre' => 'Id Padre',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getReproducens()
    {
        return $this->hasMany(Reproducen::className(), ['id_tematica' => 'id_tematica']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getLibros()
    {
        return $this->hasMany(Libros::className(), ['id_libro' => 'id_libro'])->viaTable('reproducen', ['id_tematica' => 'id_tematica']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPadre()
    {
        return $this->hasOne(Tematicas::className(), ['id_tematica' => 'id_padre']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getTematicas()
    {
        return $this->hasMany(Tematicas::className(), ['id_padre' => 'id_tematica']);
    }
}

controllers/TematicasController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Tematicas;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * TematicasController implements the CRUD actions for Tematicas model.
 */
class TematicasController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Tematicas models.
     * @return mixed
     */
    public function actionIndex()
    {
       
        $modelo= Tematicas::find()->where(['id_padre'=>1])->all();
            
        return $this->render('index', [
            'modelo' => $modelo,
        ]);
    }
    
    public function actionMuestralibros($id){
        $modelo= Tematicas::find()->where(['id_padre'=>1])->all();
        $consulta= Tematicas::find()->where(['id_tematica'=>$id])->all();
        foreach($consulta as $valor){
            $libros=$valor->getLibros()->all();
        }
              
        return $this->render('index', [
            'modelo' => $modelo,'libros'=>$libros,'id_pulsada'=>$id
        ]);
        
    }
    
    public function actionIndex2(){
        $modelo= Tematicas::find()->where(['id_padre'=>1])->all();
  
        return $this->render('index2',['datos'=>$modelo]);
    }
    
    public function actionLibrosgenerales(){
        $id = $_POST['id'];
        $consulta= Tematicas::find()->where(['id_tematica'=>$id])->all();
        foreach($consulta as $reg){
            $libros=$reg->getLibros()->all();
            foreach($libros as $libro){
                echo "<br>". \yii\helpers\Html::a($libro->titulo,['libros/view','id'=>$libro->id_libro])."<br>";
            }
        }
    }

    /**
     * Displays a single Tematicas model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Tematicas model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Tematicas();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_tematica]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Tematicas model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_tematica]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Tematicas model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Tematicas model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Tematicas the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Tematicas::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

views/tematicas/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Tematicas */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="tematicas-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'tematica')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'id_padre')->textInput() ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/tematicas/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model app\models\Tematicas */

$this->title = 'Create Tematicas';
$this->params['breadcrumbs'][] = ['label' => 'Tematicas', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="tematicas-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/tematicas/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;



/* @var $this yii\web\View */

$this->title = 'Tematicas y subtématicas';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="tematicas-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Crear Temática', ['create'], ['class' => 'btn btn-success']) ?>
    </p>

    <?php
        foreach($modelo as $valor){
    ?>
    <div class="panel panel-success">
        <div class="panel-heading "><h4><?= $valor["tematica"] ?></h4></div>
        <div class="panel-body">
           <?php  
               $tematicas=$valor->getTematicas()->asArray()->all();
               foreach($tematicas as $tema){
                   echo"<h4>". Html::a($tema['tematica'],['tematicas/muestralibros','id'=>$tema['id_tematica']])."</h4>";
                   
                   if(isset($id_pulsada) && $id_pulsada==$tema['id_tematica']){
                        if(isset($libros)){
                            foreach ($libros as $libro){
                                echo $libro->titulo."<br>";
                            }
                        }
                   }
               }
              
           ?>
        </div>
    </div>
    <?php    
        }
    ?>

</div>

views/tematicas/index2.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\BaseUrl;



/* @var $this yii\web\View */

$this->title = 'Tematicas Generales';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="tematicas-index">

    <h1><?= Html::encode($this->title) ?></h1>
    <?php
    //var_dump($datos);
    
    foreach($datos as $val){
    ?>
    <div class="panel panel-primary">
        <div class="panel-heading"><?= $val["tematica"] ?></div>
         <div class="panel-body">
            <?php
                $cuenta= Yii::$app->db->createCommand("SELECT COUNT(*) cuenta FROM reproducen WHERE id_tematica=".$val["id_tematica"])->queryAll();
                foreach ($cuenta as $v){
                    echo "<a onclick='funcion1(this)' href='#' id=".$val['id_tematica']." >Nº de Títulos: ". $v["cuenta"]."</a>";
                    
                }
                echo "<div style='display:none' id='div".$val["id_tematica"]."'></div>"
            ?>
        </div>
    </div>
    <?php
    }
    ?>
    <script>
    function funcion1(e)
    {
        id=$(e).attr('id');
        
        $.ajax({
           url: 'librosgenerales',
           type: 'post',
           data: {id: id},
           success: function (data) {
               $("#div"+id).html(data);
               $("#div"+id).toggle("slow");
           }

      });
    }
</script>
</div>

views/tematicas/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Tematicas */

$this->title = 'Update Tematicas: ' . $model->id_tematica;
$this->params['breadcrumbs'][] = ['label' => 'Tematicas', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->id_tematica, 'url' => ['view', 'id' => $model->id_tematica]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="tematicas-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/tematicas/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Tematicas */

$this->title = $model->id_tematica;
$this->params['breadcrumbs'][] = ['label' => 'Tematicas', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="tematicas-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->id_tematica], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->id_tematica], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id_tematica',
            'tematica',
            'id_padre',
        ],
    ]) ?>

</div>